void RunFmsEvDisplay2(int nevents = 9000, const char* file = "9069064.list")
{
  // Load shared libraries
  gROOT->Macro("loadMuDst.C");
  gROOT->Macro("LoadLogger.C");
  gSystem->Load("StTpcDb");
  gSystem->Load("StDetectorDbMaker");
  gSystem->Load("StDbUtilities");
  gSystem->Load("StDaqLib");
  gSystem->Load("StEmcRawMaker");
  gSystem->Load("StEmcADCtoEMaker");
  gSystem->Load("StPreEclMaker");
  gSystem->Load("StEpcMaker");
  gSystem->Load("StDbBroker");
  gSystem->Load("St_db_Maker");
  
  // Load your shared libraries here
  gSystem->Load("StFmsAnalysisMaker");
  gStyle->SetPalette(1);
  // Create chain
  StChain* chain = new StChain;

  // Instantiate MuDst maker
  StMuDstMaker* muDstMaker = new StMuDstMaker(0,0,"",file,".",1000,"MuDst");
  StMuDbReader* muDB = StMuDbReader::instance();

  // Database
  //St_db_Maker* starDb = new St_db_Maker("StarDb", "MySQL:StarDb");
  
  // Instantiate your makers here
  StFmsAnalysisMaker* fms = new StFmsAnalysisMaker;
  fms->SetFile("fms.root");
  TCanvas* c1=new TCanvas("c1","c1",600,800);
  TCanvas* c0=new TCanvas("c0","c0",600,600);

  Edep ec;
  // Initialize chain
  chain->Init();
  { 
    FitTower::Setwe_ab(0.8,.3,-.1,.8,.2,7.6);
  };

  StFmsAnalysisMaker* fmsMaker=chain->GetMaker("StFmsAnalysisMaker");

  TH2F* FmsH[4];
  TGraph* gr[4];
  TString detitle;
  TH2F* DetE[4];
  TH2F* FitDet[4];
  TH2F* Accum[4];
  TH2F* g1[4];
  TH2F* g2[4];
  TH2F* g12[4];
  Float_t PairMass[4];
  TString nam1[4]={"NorthLarge","SouthLarge","NorthSmall","SouthSmall"};
  TString nam2[4]={"FitNLarge","FitSLarge","FitNSmall","FitSSmall"};
  TString nam0[4]={"GainNL","GainSL","GainNS","GainSS"};
  c0->Divide(2,2);
  for(int jj=0;jj<4;jj++)
    {
      gr[jj]=0;
      c0->cd(jj+1);
      DetE[jj]=FitDet[jj]=0;
      TString ng=nam0[jj]+"_gn";
      TString ngc=nam0[jj]+"_gc";
      g1[jj]=new TH2F(*(fmsMaker->GetRgain()->tm(2,jj+1)));
      g1[jj]->SetName(ng);
      g2[jj]=new TH2F(*(fmsMaker->GetRgaincorr()->tm(2,jj+1)));
      g2[jj]->SetName(ngc);
      g2[jj]->SetLineColor(2);
      //      g1[jj]->Draw("box");
      //      g2a[jj]->Draw("boxsame");
      g12[jj]=new TH2F((*(g1[jj]))*(*(g2[jj])));
      g12[jj]->SetName(ng+ngc);
      g12[jj]->Draw("box");
      g12[jj]->SetStats(0);
      Accum[jj]=new TH2F(*g12[jj]);
      ng="accum";
      ng=ng+jj;
      Accum[jj]->SetTitle(ng);
      Accum[jj]->Draw("zcol");
    };
  c1->Divide(2,4);
  Int_t PlotCnt=0;
  // Event loop
  for (int iEvent = 4847; iEvent <= nevents; ++iEvent) 
    {
      chain->Clear();
      int status = chain->Make(iEvent);
      if (status % 10 == kStEOF || status % 10 == kStFatal) break;
      char s20[20];
      sprintf(s20,"%d",iEvent);
      TString ev("iEvent= ");

      ev=ev+TString(s20);
      Bool_t highEPi0=false;
      for(int jj=0;jj<4;jj++)
	{
	  TMatrix* ma=fmsMaker->GetEnergy(jj);
	  for(int r=0;r<ma->GetNrows();r++)
	    {
	      for(int c=0;c<ma->GetNcols();c++)
		{
		  Accum[jj]->Fill((float) c+.5,(float) r+.5,(*ma)(r,c));
		};
	    };
	  Yiqun* rec=fmsMaker->p_rec[jj];
	  if(rec==0)continue;
	  PairMass[jj]=0;
	  Geom* p_geom=rec->p_geom;

	  Float_t phx[100],phy[100];
	  for(int k=0;k<rec->NPh;k++)
	    {
	      Float_t d=3.81;
	      if(k>1)d=5.8;
	      phx[k]=p_geom->LocalXYZ(2,jj+1,rec->ph_coord_lab(k),true).X();
	      phy[k]=p_geom->LocalXYZ(2,jj+1,rec->ph_coord_lab(k),true).Y();
	    };

	  if(gr[jj])delete gr[jj];
	  gr[jj]=0;
	  if(rec->NPh>0)gr[jj]=new TGraph(rec->NPh,phx,phy);
	  if(rec->NPh==1&& false )
	    {
	      Float_t E1=rec->mom(0).E();
	      cout<<ev<<" jj="<<jj<<" E1="<<E1<<"\n";
	      if(E1>45)highEPi0=true;
	    };
	  if(rec->NPh==2 && true)
	    {
	      Float_t E2=(rec->mom(0).E())+(rec->mom(1).E());
	      Float_t M2=((rec->mom(0))+(rec->mom(1))).Mag();
	      PairMass[jj]=M2;
	      cout<<ev<<" jj="<<jj<<" E2="<<E2<<" M2="<<M2;
	      cout<<" NRealClusts="<< rec.NRealClusts;
	      for(int ji=0;ji<rec.NRealClusts;ji++)
		{
		  cout<<"("<<rec.clust[ji].catag<<","<<
		    rec.clust[ji].chiSquare<<") ";
		  
		}
	      cout<<"  \n";
	      if(E2>32 && fabs(M2)<.7)highEPi0=true;
	    };
	};

      if(!highEPi0)continue;
      for(int jj=0;jj<4;jj++)
	{
	  if(DetE[jj])delete DetE[jj];
	  if(FitDet[jj])delete FitDet[jj];
	  DetE[jj]=new TH2F(*(fmsMaker->GetEnergy(jj)));
	  DetE[jj]->SetName(nam1[jj]);
	  DetE[jj]->SetStats(0);
	  DetE[jj]->SetMaximum(60);
	  DetE[jj]->SetMinimum(.001);
	  detitle=ev+TString(" FMS E(ucor)=");
	  for(int kk=0;kk<fmsMaker->p_rec[jj]->NPh;kk++)
	    {
	      char str[40];
	      sprintf(str,"%3.1f ",fmsMaker->p_rec[jj]->mom(kk).E());
	      detitle=detitle+TString(str);
	    };
	  char str3[20];
	  sprintf(str3," M12=%3.3f",PairMass[jj]);
	  detitle=detitle +TString(str3);

	  DetE[jj]->SetTitle(detitle);
	  cout<<"det title ="<<detitle<<"\n";

	  detitle=ev+TString(" Fit E(ucor)");

	  FitDet[jj]=new TH2F( fmsMaker->p_rec[jj]->FittedMat() );
	  FitDet[jj]->SetTitle(detitle);
	  FitDet[jj]->SetName(nam2[jj]);
	  FitDet[jj]->SetMinimum(.001);
	  FitDet[jj]->SetMaximum(60.);
	  FitDet[jj]->SetStats(0);
	  c1->cd(2*jj+1);
	  c1->GetPad(2*jj+1)->SetLogz();
	  DetE[jj]->Draw("zcol");
	  DetE[jj]->Draw("boxsame");
	  if(gr[jj])gr[jj]->Draw("*");
	  c1->cd(2*jj+2);
	  c1->GetPad(2*jj+2)->SetLogz();
	  FitDet[jj]->Draw("zcol");
	  FitDet[jj]->Draw("boxsame");
	  if(gr[jj])gr[jj]->Draw("*");
	  c0->cd(jj+1);
	  c0->GetPad(jj+1)->SetLogz();
	  c0->Draw("zcol");
	};
      Int_t npages=2;
      if(PlotCnt==0)
	{
	  c1->Print("events.ps(");
	}
      else if(PlotCnt<npages)
	{
	  c1->Print("events.ps");
	}
      else if(PlotCnt==npages)
	{
	  c1->Print("events.ps)");
	};
      PlotCnt++;
      
      c1->Update();
      c0->Update();
      if(PlotCnt>npages)break;
    }
}
  
